/**
 * @class accelerometer
 * @extends node
 * The accelerometer receives acceleration data where available.
 * <br/><a href="/examples/sensors">example &raquo;</a>
 * 
 * <iframe style="border:0;width:900px;height:300px" src="/apps/docs/example#path=$sensors/accelerometer.js"></iframe>
 * <a target="blank" href="/apps/docs/example#path=$sensors/accelerometer.js">open example in new tab &raquo;</a>
 * 
 */
/**
 * @attribute {Boolean} [supported="false"]
 * True if accelerometer is supported
 */
/**
 * @attribute {vec3} [acceleration="0,0,0"]
 * Three component (x, y, z) instant acceleration of the device
 */
/**
 * @attribute {typeless} [x="undefined"]
 * Alias for the x component of acceleration
 */
/**
 * @attribute {typeless} [y="undefined"]
 * Alias for the y component of acceleration
 */
/**
 * @attribute {typeless} [z="undefined"]
 * Alias for the z component of acceleration
 */