/**
 * @class icon
 * @extends label
 * @unsupported DALi
 * The icon class provides an easy way to access most of the commonly used web icons. Look at the FontAwesome cheat sheet to see what can be used.
 * 
 * <iframe style="border:0;width:900px;height:300px" src="/apps/docs/example#path=$ui/icon.js"></iframe>
 * <a target="blank" href="/apps/docs/example#path=$ui/icon.js">open example in new tab &raquo;</a>
 * 
 */
/**
 * @attribute {String} [icon="wrench"]
 * The icon to be used. Look at the FontAwesome cheat sheet to see the available options. Icons do not need to specify their 'fa-' prefix -> use 'gears' instead of 'fa-gears'.
 */