# Examples
There are a number of examples designed to help you see recommended practices with DreemGL. 

| Example        | Description  | 
| -------------- |:-------------|
| audio.js       | Visualization of the DreemGL audioplayer|
| audio2.js      | Visualizaiton of the DreemGL audioplayer with controls for start, stop, pause, along with the elapsed time of the audio.|
| buttons.js     | Example of basic buttons, text alignment, buttons with images, and radio buttons.|
| calculator.js  | Basic calculator with simple operations.|
| checkboxes.js  | Example of basic selected and unselected checkboxes, icon checkboxes with text, and checkboxes with images.|
| drawers.js     | Drawer with left and right swipes, and a single drawer with a right swipe.|
| flow.js        | Sample composition demonstrating complex wiring.  Intended for use with flowgraph.|
| inputdevice.js | Example that displays input events, like position, click, hover, wheel, and so on.|
| lists.js       | Simple scrollable list example: vertical, horizontal, and position that is adjusted programmatically with buttons.|
| morph.js       | Shape morphing from a square to a circle to a cross.|
| rpcremote.js   | Example of using rpc to remotely control a square. Add '?remote' to the URL for one window; and add '?mobile' to the URL of the second window. Use the mobile screen to remotely drag around the square on the remote screen.|
| selection.js   | Basic example of dragging a selection square around a block of text.|
| sensors.js     | If opened on a mobile device with accelerometer, gyroscope or ambeint light sensor available this example will display those available sensor readings.|
| sliders.js     | Example of a basic slider that displays a current value, as well as a custom handle with an image. |
| tables.js      | Standard example showing tables constructed with rows and columns that include text or images and can be syled with borders and background colors. |
| text.js        | An example with static text, multiline text, text with background images, styled text, and corresponding text boxes that can be used as input fields. |
| timeline.js    | Interactive example of the timeline component, with draggable events.|
| treeart.js     | Shader animation of a tree. |
| treeart2.js    | A different shader animation of a tree. |
| usingtoolkit.js | A sample visual layout toolkit, including a panel, images, and text. |
