Ext.data.JsonP.iot({"tagname":"class","name":"iot","autodetected":{},"files":[{"filename":"iot.js","href":"iot.html#iot"}],"extends":"service","members":[{"name":"connected","tagname":"attribute","owner":"iot","id":"attribute-connected","meta":{}},{"name":"things","tagname":"attribute","owner":"iot","id":"attribute-things","meta":{}},{"name":"addListener","tagname":"method","owner":"node","id":"method-addListener","meta":{}},{"name":"connect","tagname":"method","owner":"iot","id":"method-connect","meta":{}},{"name":"find","tagname":"method","owner":"node","id":"method-find","meta":{}},{"name":"findChild","tagname":"method","owner":"node","id":"method-findChild","meta":{}},{"name":"mixin","tagname":"method","owner":"node","id":"method-mixin","meta":{}},{"name":"removeListener","tagname":"method","owner":"node","id":"method-removeListener","meta":{}},{"name":"update","tagname":"method","owner":"iot","id":"method-update","meta":{}},{"name":"updateAll","tagname":"method","owner":"iot","id":"method-updateAll","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-iot","short_doc":"The iot class makes it very easy to connect to a wide variety of devices including\nSmartThings, Philips Hue and many ...","classIcon":"icon-class","superclasses":["node","service"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/node' rel='node' class='docClass'>node</a><div class='subclass '><a href='#!/api/service' rel='service' class='docClass'>service</a><div class='subclass '><strong>iot</strong></div></div></div><h4>Files</h4><div class='dependency'><a href='source/iot.html#iot' target='_blank'>iot.js</a></div></pre><div class='doc-contents'><p>The iot class makes it very easy to connect to a wide variety of devices including\nSmartThings, Philips Hue and many more.</p>\n\n<p>IMPORTANT: see /examples/components/iot/README.md for setup instructions.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-attribute'>Attributes</h3><div class='subsection'><div id='attribute-connected' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='iot'>iot</span><br/><a href='source/iot.html#iot-attribute-connected' target='_blank' class='view-source'>view source</a></div><a href='#!/api/iot-attribute-connected' class='name expandable'>connected</a> : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>If true, we are connected ...</div><div class='long'><p>If true, we are connected</p>\n<p>Defaults to: <code>&quot;false&quot;</code></p></div></div></div><div id='attribute-things' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='iot'>iot</span><br/><a href='source/iot.html#iot-attribute-things' target='_blank' class='view-source'>view source</a></div><a href='#!/api/iot-attribute-things' class='name expandable'>things</a> : Array<span class=\"signature\"></span></div><div class='description'><div class='short'>A list of things connected to the hub, automatically updated as new devices are discovered and their state changes. ...</div><div class='long'><p>A list of things connected to the hub, automatically updated as new devices are discovered and their state changes.\nEach thing consists of an object containing an id, name, and a state object representing its current state's value type, unit and if it's readonly or not where available.</p>\n<p>Defaults to: <code>&quot;&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addListener' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-addListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-addListener' class='name expandable'>addListener</a>( <span class='pre'>key, cb</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>add a listener to an attribute ...</div><div class='long'><p>add a listener to an attribute</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>cb</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-connect' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='iot'>iot</span><br/><a href='source/iot.html#iot-method-connect' target='_blank' class='view-source'>view source</a></div><a href='#!/api/iot-method-connect' class='name expandable'>connect</a>( <span class='pre'>iotdb</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Override to change what gets connected. ...</div><div class='long'><p>Override to change what gets connected. Currently attempts to connect all devices.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>iotdb</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-find' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-find' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-find' class='name expandable'>find</a>( <span class='pre'>name</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Finds a parent node by name. ...</div><div class='long'><p>Finds a parent node by name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-findChild' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-findChild' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-findChild' class='name expandable'>findChild</a>( <span class='pre'>name</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Finds a child node by name. ...</div><div class='long'><p>Finds a child node by name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-mixin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-mixin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-mixin' class='name expandable'>mixin</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Mixes in another class or object, just pass in any number of object or class references. ...</div><div class='long'><p>Mixes in another class or object, just pass in any number of object or class references. They are copied on key by key</p>\n</div></div></div><div id='method-removeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-removeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-removeListener' class='name expandable'>removeListener</a>( <span class='pre'>key, cb</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>remove a listener from an attribute, uses the actual function reference to find it\nif you dont pass in a function ref...</div><div class='long'><p>remove a listener from an attribute, uses the actual function reference to find it\nif you dont pass in a function reference it removes all listeners</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>cb</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-update' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='iot'>iot</span><br/><a href='source/iot.html#iot-method-update' target='_blank' class='view-source'>view source</a></div><a href='#!/api/iot-method-update' class='name expandable'>update</a>( <span class='pre'>thingid, state, value</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Updates a specific thing's state to a new value ...</div><div class='long'><p>Updates a specific thing's state to a new value</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>thingid</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>state</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>value</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-updateAll' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='iot'>iot</span><br/><a href='source/iot.html#iot-method-updateAll' target='_blank' class='view-source'>view source</a></div><a href='#!/api/iot-method-updateAll' class='name expandable'>updateAll</a>( <span class='pre'>state, value</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Updates all things to a new value ...</div><div class='long'><p>Updates all things to a new value</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>state</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>value</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});